package org.cytoscape.work.internal.sync;

/*
 * #%L
 * org.cytoscape.work-impl
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2006 - 2013 The Cytoscape Consortium
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 2.1 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-2.1.html>.
 * #L%
 */


import java.lang.reflect.Field;
import java.lang.reflect.Method;

import org.cytoscape.work.Tunable;
import org.cytoscape.work.TunableHandlerFactory;


public class SyncTunableHandlerFactory implements TunableHandlerFactory<SyncTunableHandler> {

	public SyncTunableHandler createTunableHandler(final Field field, final Object instance, final Tunable tunable) {
		return new SyncTunableHandler(field,instance,tunable);
	}

	public SyncTunableHandler createTunableHandler(final Method getter, final Method setter, final Object instance, final Tunable tunable) {
		return new SyncTunableHandler(getter,setter,instance,tunable);
	}
}
